using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DropDownLists
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 


	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private Syncfusion.Windows.Forms.Grid.GridBoundColumn gridBoundColumn1;
		private Syncfusion.Windows.Forms.Grid.GridBoundColumn gridBoundColumn2;
		private Syncfusion.Windows.Forms.Grid.GridBoundColumn gridBoundColumn3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private ArrayList dataCollection = new ArrayList();
		private ArrayList selectorArray = new ArrayList();
		private ArrayList data1Array = new ArrayList();
		private ArrayList data2Array = new ArrayList();
		private System.Windows.Forms.Button buttonRemove;

		int lastSelector = -1;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


			for( int i = 0; i < 10; i++ )
			{
				dataCollection.Add( new DropDownLists.Data(i) );
				selectorArray.Add( i );
				data1Array.Add("A0");
				data2Array.Add("0A");
			}

			this.gridDataBoundGrid1.DataSource = dataCollection;
			//this.gridDataBoundGrid1.CurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventHandler(gridDataBoundGrid1_CurrentCellShowingDropDown);
			this.gridDataBoundGrid1.CurrentCellActivating += new Syncfusion.Windows.Forms.Grid.GridCurrentCellActivatingEventHandler(gridDataBoundGrid1_CurrentCellActivating);
			this.gridDataBoundGrid1.CurrentCellMoveFailed += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMoveFailedEventHandler(gridDataBoundGrid1_CurrentCellMoveFailed);
			this.buttonRemove.Click += new EventHandler(buttonRemove_Click);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.gridBoundColumn1 = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.gridBoundColumn2 = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.gridBoundColumn3 = new Syncfusion.Windows.Forms.Grid.GridBoundColumn();
			this.buttonRemove = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AccessibilityEnabled = true;
			this.gridDataBoundGrid1.ActivateCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridCellActivateAction.DblClickOnCell;
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.ControllerOptions = ((Syncfusion.Windows.Forms.Grid.GridControllerOptions)(((((Syncfusion.Windows.Forms.Grid.GridControllerOptions.ClickCells | Syncfusion.Windows.Forms.Grid.GridControllerOptions.DragSelectRowOrColumn) 
				| Syncfusion.Windows.Forms.Grid.GridControllerOptions.SelectCells) 
				| Syncfusion.Windows.Forms.Grid.GridControllerOptions.ExcelLikeSelection) 
				| Syncfusion.Windows.Forms.Grid.GridControllerOptions.ResizeCells)));
			this.gridDataBoundGrid1.GridBoundColumns.AddRange(new Syncfusion.Windows.Forms.Grid.GridBoundColumn[] {
																													  this.gridBoundColumn1,
																													  this.gridBoundColumn2,
																													  this.gridBoundColumn3});
			this.gridDataBoundGrid1.HorizontalThumbTrack = true;
			this.gridDataBoundGrid1.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.Properties.RowHeaders = false;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(624, 312);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ThemesEnabled = true;
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.VerticalThumbTrack = true;
			// 
			// gridBoundColumn1
			// 
			this.gridBoundColumn1.HeaderText = "Selector";
			this.gridBoundColumn1.MappingName = "Selector";
			this.gridBoundColumn1.StyleInfo.CellType = "ComboBox";
			// 
			// gridBoundColumn2
			// 
			this.gridBoundColumn2.HeaderText = "Data 1";
			this.gridBoundColumn2.MappingName = "Data1";
			this.gridBoundColumn2.StyleInfo.CellType = "ComboBox";
			// 
			// gridBoundColumn3
			// 
			this.gridBoundColumn3.HeaderText = "Data 2";
			this.gridBoundColumn3.MappingName = "Data2";
			this.gridBoundColumn3.StyleInfo.CellType = "ComboBox";
			// 
			// buttonRemove
			// 
			this.buttonRemove.Location = new System.Drawing.Point(416, 368);
			this.buttonRemove.Name = "buttonRemove";
			this.buttonRemove.TabIndex = 1;
			this.buttonRemove.Text = "Remove";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 434);
			this.Controls.Add(this.buttonRemove);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

//		private void gridDataBoundGrid1_RowEnter(object sender, Syncfusion.Windows.Forms.Grid.GridRowEventArgs e)
//		{
//			int m_CurrentSelectedRowIndex = this.gridDataBoundGrid1.CurrentCell.ColIndex;
//
//			if( this.gridDataBoundGrid1.DataSource != null )
//				if( (this.gridDataBoundGrid1.DataSource as ArrayList).Count > 0 )
//					this.SetupDataDropDownValues(((Data)((this.gridDataBoundGrid1.DataSource as ArrayList)[m_CurrentSelectedRowIndex-1])).Selector );
//		}

		private void SetupDataDropDownValues( int selector )
		{
			if (selector == lastSelector)
				return;

			lastSelector = selector;

			this.data1Array = new ArrayList();
			this.data2Array = new ArrayList();

			foreach( Syncfusion.Windows.Forms.Grid.GridBoundColumn gridColumn in gridDataBoundGrid1.GridBoundColumns )
			{
				if( (gridColumn.MappingName == "Data1") || (gridColumn.MappingName == "Data2") )
					gridColumn.StyleInfo.DropDownStyle = Syncfusion.Windows.Forms.Grid.GridDropDownStyle.AutoComplete;
			}

			for( int i = 0; i < 5; i++ )
			{
				this.data1Array.Add( String.Format( "{0}{1}", selector.ToString(), ((char)('A'+ i)).ToString()) );
				this.data2Array.Add( String.Format( "{0}{1}", ((char)('A'+ i)).ToString(), selector.ToString()) );
			}

			this.gridBoundColumn2.StyleInfo.DataSource = this.data1Array;
			this.gridBoundColumn3.StyleInfo.DataSource = this.data2Array;

		}

		void UpdateSelector(int rowIndex)
		{
			int m_CurrentSelectedRowIndex = rowIndex;

			if( this.gridDataBoundGrid1.DataSource != null )
				if( (this.gridDataBoundGrid1.DataSource as ArrayList).Count > 0 )
					this.SetupDataDropDownValues(((Data)((this.gridDataBoundGrid1.DataSource as ArrayList)[m_CurrentSelectedRowIndex-1])).Selector );
		}



		private void gridDataBoundGrid1_CurrentCellActivating(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellActivatingEventArgs e)
		{
			Syncfusion.Windows.Forms.Grid.GridControlBase grid = (Syncfusion.Windows.Forms.Grid.GridControlBase) sender;
			UpdateSelector(e.RowIndex);
		}

		private void gridDataBoundGrid1_CurrentCellMoveFailed(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMoveFailedEventArgs e)
		{
			Syncfusion.Windows.Forms.Grid.GridControlBase grid = (Syncfusion.Windows.Forms.Grid.GridControlBase) sender;
			UpdateSelector(grid.CurrentCell.RowIndex);
		}

		private int GetSelectedRow()
		{
			int retValue = 0;

			Syncfusion.Windows.Forms.Grid.GridRangeInfoList rangeInfo;
			
			rangeInfo = this.gridDataBoundGrid1.Selections.GetSelectedRows(true, false);
			for( int i = 0; i < rangeInfo.Count; i++ )
			{
				retValue = rangeInfo[i].Top;
				if( retValue > (this.gridDataBoundGrid1.DataSource as ArrayList).Count )
					this.gridDataBoundGrid1.Selections.Clear(false);
			}
			return retValue;
		}

		private void buttonRemove_Click(object sender, EventArgs e)
		{

			int index = GetSelectedRow();

			(this.gridDataBoundGrid1.DataSource as ArrayList).RemoveAt( index - 1 );
			this.gridDataBoundGrid1.Invalidate();
			this.gridDataBoundGrid1.Refresh();
		}
	}

	public class Data
	{
		public int Selector
		{
			get
			{
				return m_Selector;
			}
			set
			{
				m_Selector = value;
			}
		}
		private int m_Selector;

		public string Data1
		{
			get
			{
				return m_Data1;
			}
			set
			{
				m_Data1 = value;
			}
		}
		private string m_Data1;

		public string Data2
		{
			get
			{
				return m_Data2;
			}
			set
			{
				m_Data2 = value;
			}
		}
		private string m_Data2;

		public Data( int selector )
		{
			m_Selector = selector;
			m_Data1 = String.Format( "{0}{1}", selector.ToString(), ((char)('A'+selector)).ToString() );
			m_Data2 = String.Format( "{0}{1}", ((char)('A'+selector)).ToString(), selector.ToString() );
		}
	}
}
